Description

Lei Dou at UC Davis is working on a module that extends Kepler functionality. It, like many other modules, has workflow demos. The
problem is this. These demos should not go into the outreach module, which is part of Kepler/CORE. But, since on the Mac when
things are installed, the modules are in the Kepler.app, the demos are not available.

The solution is to have demos that are contributed by a module be copied to KeplerData/Kepler-2.0-Demos/demos upon start up if
they are not already present upon start-up.

This should be done before the 2.0 release. It will be necessary to make a 4th release candidate before doing the 2.0.0 release.

Related issues:
Blocked by Kepler - Bug #4943: RC5 Installer Tracking Bug Resolved 04/19/2010

History

#1 - 05/28/2010 01:28 PM - David Welker

Proposed solution:

(1) For each module in the current set:
-- Check if there is a demo directory. (This should be determined based on a getter method in Module.java. If it doesn't exist, create it.) If there is a
demo directory, check to see if KeplerData/demos/<module-including-version> exists. If it doesn't exist, copy the demo directory over.

For data, data should be a subdirectory of the demo directory.

(2) For each module in the current set:

Set a system property as follows:

The stem name of the module plus the string ".demodir" is the name of the property. The demo directory of the module is the value of the property.
#2 - 05/28/2010 02:40 PM - David Welker

Oh, | nearly forgot. We need a docs directory to.

(3) For each module in the current set:

-- Check if there is a docs directory for the module. (This should be determined based on a

getter method in Module.java. If such a method does not does not exist, create it.) If there is a

docs directory, check to see if KeplerData/docs/<module-including-version>
exists. If it doesn't exist, copy the demo directory over.

#3 - 05/28/2010 03:39 PM - Derik Barseghian

Not mentioned in the bug but the idea was to copy all modules' module/resources/demos dirs. But we've changed the plan a bit: we'll copy from
module/workflows/demos instead. Anything in resources goes on the classpath, and we didn't see a need for workflows to be on the classpath. Also,
a module dev may want to maintain workflows that aren't demos. Modules keep their workflows in a few different locations currently, I'll try to organize
appropriately. Objections? I'll try fix any path problems | notice inside the workflows | move...

#4 - 05/28/2010 08:51 PM - Derik Barseghian
This is mostly done now in trunk and 2.0.
After futher discussion w/ David and Sean, we decided to change to copy all <module>/workflows into KeplerData/workflows<module>/ .

The user folder ("default local repository") is now KeplerData/workflows/Myltems. I'm happy to rename this if people don't like it, but | thought
continuing to call it Workflows when it's actually just a subdir of workflows might be confusing.
<module>/documentation/ is now copied into KeplerData/documentation/<module>/

I've moved all the workflows | found into the appropriate locations. | now need to open and fix all workflows that use old system properties to change
to the new <moduleStemName>.demodir properties. | tested this on a number of workflows and it worked.

#5 - 05/30/2010 01:15 AM - David Welker

Changing the "documentation” folder to "docs." Also, putting it at the top level of a module, rather than within the "resources" directory.

#6 - 06/01/2010 10:48 AM - Derik Barseghian

(In reply to comment #5)

Changing the "documentation" folder to "docs." Also, putting it at the top
level of a module, rather than within the "resources" directory.

Hey David,

Having made this change, you'll now need to move reporting, workflow-run-manager, and tagging documents found in <module>/documentation/ into
respective docs dir, and figure out what to do with the tagging design documents currently found in tagging/docs. You'll then need to fix the Kepler gui
Help=> Documentation code that looks for documents in documentation/.

#7 - 06/01/2010 01:10 PM - Derik Barseghian
Typo in Comment#4, the new properties are not <modulename>.demodir, but <modulename>.workflowdir.

I've updated all the paths | found in our workflows to use <modulename>.workflowdir instead of DEMODIR. It will be good to ensure these work in the
next installer version.

After Comment#6 is fixed, we should be able to close this bug.

#8 - 06/02/2010 01:10 PM - David Welker

Closing this bug. We may need to re-open this bug or a new bug in order to deal with the change in location of documentation from
resources/documentation to docs/.

#9 - 06/07/2010 01:43 PM - Derik Barseghian

Why was this closed? From what | can tell Help => Modules Documentation is still broken because the files haven't been moved into docs/ yet. I'l
move them. Let me know if these were intentionally not moved or I've misunderstood something.

#10 - 06/07/2010 03:59 PM - Derik Barseghian

The files had been moved in 2.0 but not trunk. | moved the ones in trunk.

#11 - 03/27/2013 02:28 PM - Redmine Admin
Original Bugzilla ID was 5034
